<template>
  <flink
    :href="`/do/part/${entity.id}`"
    target="_blank"
    rel="noopener"
    @click.native="$ym('click_ads_block')"
    class="appCardOffer">
    <div class="appCardOffer-wrapper">
      <div class="appCardOffer-image">
        <img
          v-if="entityPhoto.count"
          :src="entityPhoto.src"
          :alt="entityPhoto.alt">
        <div
          v-else
          class="noPhoto">
          <img
            svg-inline
            src="~/assets/svg/redesign/navigation-parts.svg">
        </div>
      </div>
      <div class="appCardOffer-desc">
        <span class="appCardOffer-title">
          {{ entity.name | sellerPartName }}
        </span>
        <span class="appCardOffer-price">
          {{ entity.cost | round | spacifyNumber }} ₽
        </span>
      </div>
      <footer class="appCardOffer-footer">
        <span class="appCardOffer-state">
          {{ entity.actualAt | dateFormat({ time: true, nouns: true }) }}
        </span>
        <span class="appCardOffer-state">
          {{ getLocation(entity) }}
        </span>
      </footer>
    </div>
  </flink>
</template>

<script>
// TODO: ИМХО, стоит просто вынести метод в getLocation в helpers
import ContractPart from '~/assets/js/mixins/contract-part';

export default {
  name: 'AppCardOffer',
  mixins: [ContractPart],
  props: {
    entity: {
      type: Object,
      default() {
        return {};
      },
    },
  },
  computed: {
    entityPhoto() {
      const length = this.entity.images.length;
      return {
        count: length,
        // eslint-disable-next-line no-undef
        src: length ? `${this.$config.imagesBaseUrl}${this.entity.images[0].big.url}` : '~/assets/svg/goods-item.svg',
        alt: length ? this.entity.title : 'нет фото',
      };
    },
  },
};
</script>

<style scoped lang="postcss">
  .appCardOffer {
    display: flex;
    flex-direction: column;
    padding: 0 0.625rem;
    width: 100%;
    height: 100%;
    font-size: 0.75rem;
    color: var(--color-main);

    &-wrapper {
      display: flex;
      flex-direction: column;
      width: 100%;
      height: 18.75rem;
      background-color: var(--bg-main);
      border: 1px solid var(--border-color-main);
      box-shadow: 0 2px 4px rgba(0, 0, 0, 0.11);
    }

    &-image {
      display: flex;
      align-items: center;
      justify-content: center;
      flex-shrink: 0;
      width: 100%;
      height: 12.5rem;
      border-bottom: 1px solid var(--border-color-main);

      img {
        display: block;
        height: 100%;
        width: 100%;
        object-fit: contain;
      }

      .noPhoto {
        display: flex;
        justify-content: center;
        align-items: center;
        width: 100%;
        height: 100%;
        background-color: var(--bg-lightest);

        .svg {
          width: 5rem;
          height: auto;
          fill: var(--fill-light);
        }
      }
    }

    &-desc {
      display: block;
      padding: 1rem 1rem 0;
    }

    &-title {
      display: block;
      font-weight: var(--font-weight-bold);

      &:first-letter {
        text-transform: capitalize;
      }
    }

    &-price {
      display: block;
      padding: 0.25rem 0;
      font-size: 1rem;
      font-weight: var(--font-weight-bold);
    }

    &-footer {
      display: flex;
      justify-content: space-between;
      margin-top: auto;
      padding: 0 1rem 1rem;
      color: var(--color-main-lightest);
    }

    @media (min-width: 981px) and (max-width: 1200px) {
      &-wrapper {
        height: 24vw;
      }

      &-image {
        height: 14vw;
      }
    }
  }

</style>
